<?php

/**
 * @package wp fancy title
 * @version 1.1
 */

// Admin Scripts
add_action('admin_enqueue_scripts', 'wft_admin_enqueue_script');
function wft_admin_enqueue_script()
{

	wp_enqueue_style('wp-color-picker');
	wp_enqueue_style('wft-admin', plugins_url('../css/wft-admin.css', __FILE__), array(), '4.1', false);
	wp_enqueue_script('repeater', plugins_url('../js/repeater.js', __FILE__), array('jquery'), '1.0.2', true);
	wp_enqueue_script('wft-admin', plugins_url('../js/wft-admin.js', __FILE__), array('jquery', 'wp-color-picker'), '1.0.1', true);
}

// Enqueue Scripts
add_action('wp_enqueue_scripts', 'wft_enqueue_script');
function wft_enqueue_script()
{

	wp_register_style('jConveyorTicker', plugins_url('../css/jquery.jConveyorTicker.min.css', __FILE__), array(), '4.1', false);

	wp_register_style('wft-min', plugins_url('../css/wft-min.css', __FILE__), array(), '1.0.0', false);

	wp_enqueue_script('jquery.mfancytitle', plugins_url('../js/jquery.mfancytitle-0.4.1.min.js', __FILE__), array('jquery'), '4.1', true);

	wp_register_script('jConveyorTicker', plugins_url('../js/jquery.jConveyorTicker.min.js', __FILE__), array('jquery'), '4.1', true);
}


function wft_option_script()
{
	$option = get_option('wft_option_name');
?>
	<script type="text/javascript">
		(function($) {
			'use strict';
			// Ticker
			$(function() {

				let conveyor = $('.wft-conveyor');

				if (conveyor.length) {

					conveyor.each(function() {
						$(this).jConveyorTicker({
							anim_duration: 500,
							reverse_elm: true,
							force_loop: true
						});

					});
				}

			});

		})(jQuery);


		jQuery.mFancyTitle({

			// miss you
			mftMissYou: <?php echo (!empty($option['miss_title_on'])) ? 'true' : 'false';  ?>,

			<?php if (!empty($option['miss_u_title'])) : ?>
				mftMissYouTitle: "<?php echo $option['miss_u_title'];  ?>",
			<?php endif; ?>


			// title Blank
			<?php if (!empty($option['title_blink']) && $option['title_blink'] == 1) : ?>
				mftTitleBlink: [true, false],
			<?php endif; ?>
			<?php if (!empty($option['title_blink']) && $option['title_blink'] == 2) : ?>
				mftTitleBlink: [false, true],
			<?php endif; ?>
			<?php if (!empty($option['title_blink']) && $option['title_blink'] == 3) : ?>
				mftTitleBlink: [true, true],
			<?php endif; ?>



			<?php if (!empty($option['blink_alt_text']) || !empty($option['miss_blink_alt_text'])) : ?>
				mftTitleAltText: ["<?php echo $option['blink_alt_text']; ?>", "<?php echo $option['miss_blink_alt_text']; ?>"],
			<?php endif; ?>

			// title marq

			<?php if (!empty($option['miss_title_marquee']) && $option['miss_title_marquee'] == '1') : ?>
				mftTitleMarquee: [true, false],
			<?php endif; ?>

			<?php if (!empty($option['miss_title_marquee']) && $option['miss_title_marquee'] == '2') : ?>
				mftTitleMarquee: [false, true],
			<?php endif; ?>

			<?php if (!empty($option['miss_title_marquee']) && $option['miss_title_marquee'] == '3') : ?>
				mftTitleMarquee: [true, true],
			<?php endif; ?>


		});
	</script>
<?php
}
add_action('wp_footer', 'wft_option_script', 100);
