<?php
/**
* @package wp fancy title
* @version 1.1
*/

// Wft Ticker post type register
function wft_post_type_register_init() {
    $labels = array(
        'name'                  => esc_html__( 'Wft Ticker', 'wft' ),
        'singular_name'         => esc_html__( 'Wft Ticker', 'wft' ),
        'menu_name'             => esc_html__( 'Wft Ticker', 'wft' )
    );

    $args = array(
        'labels'             => $labels,
        'public'             => true,
        'publicly_queryable' => false,
        'query_var'          => false,
        'rewrite'            => array( 'slug' => 'wft-ticker' ),
        'capability_type'    => 'post',
        'menu_position'      => null,
        'supports'           => array( 'title' ),
    );

    register_post_type( 'wft_ticker', $args );
}
 
add_action( 'init', 'wft_post_type_register_init' );
/**
 *
 * Add Shortcode
 *
 */
add_shortcode( 'wft_ticker', 'wft_ticker_shortcode' );
function wft_ticker_shortcode(  $atts, $content = null ) {

	$atts =shortcode_atts(array(
		'id' => ''
	), $atts);
	
    $data = get_post_meta( absint( $atts['id'] ), 'wft_ticker_meta', true );

    $tickerData = json_decode( $data , true );

    //
    $tickerlist = array();
    
    if( ! empty( $tickerData['tickerlist']['name'] ) ) {

        $tickerlist = $tickerData['tickerlist']['name'];
    }
    // Enqueue
    wp_enqueue_style( 'jConveyorTicker' );
    wp_enqueue_style( 'wft-min' );
    wp_enqueue_script( 'jConveyorTicker' );
    ob_start();
	?>
	<style>

		<?php 
		if( !empty( $tickerData['wft_ticker_lab_bg'] ) ):
		?>
		<?php echo '#wftticker_'.absint( $atts['id'] ) ?> .jctkr-label {
			background: <?php echo esc_html( $tickerData['wft_ticker_lab_bg'] ) ?>;
			color: <?php echo esc_html( $tickerData['wft_ticker_lab_color'] ) ?>;
		}
		<?php 
		endif;
		?>
		<?php 
		if( !empty( $tickerData['wft_ticker_bg'] ) ):
		?>
		<?php echo '#wftticker_'.absint( $atts['id'] ) ?>.wft-wrap {
			background: <?php echo esc_html( $tickerData['wft_ticker_bg'] );  ?>;
			color: <?php echo esc_html( $tickerData['wft_ticker_color'] ); ?>;
			border-color: <?php echo esc_html( $tickerData['wft_ticker_bord_color'] ); ?>;
		}
		<?php 
		endif;
		?>

	</style>
	<div id="<?php echo 'wftticker_'.absint( $atts['id'] ) ?>" class="wft-wrap">
		<?php
		if( !empty( $tickerData['wft_ticker_title'] ) ):
		?>
		<div class="jctkr-label">
		    <strong><?php echo esc_html( $tickerData['wft_ticker_title'] ); ?></strong>
		</div>
		<?php 
		endif;
		?>
		<div class="wft-conveyor">
			<ul>
				<?php 
				$list = '';
				if( ! empty( $tickerlist ) ) {
					foreach( $tickerlist as $ticker ) {
						$list .= '<li>'.$ticker.'</li>';
					}
				}
				echo wp_kses_post( $list );
				?>
			</ul>
		</div>
	</div>
	<?php
	return ob_get_clean();
}

// Member meta view
add_action( 'add_meta_boxes', 'wft_ticker_meta' );
function wft_ticker_meta(){
    add_meta_box(
        'wft-ticker-meta',
        esc_html__( 'Ticker Information', 'wft' ),
        'wft_ticker_meta_view',
        'wft_ticker',
        'advanced',
        'default'
    );
}
//
function wft_ticker_meta_view() {

    $data = get_post_meta( get_the_ID(), 'wft_ticker_meta', true );

    $tickerData = json_decode( $data , true );

    //
    $tickerlist = array();
    
    if( ! empty( $tickerData['tickerlist']['name'] ) ) {

        $tickerlist = $tickerData['tickerlist']['name'];
    }

    ?>

    <div class="member-meta-field">
        <div class="container">
            <div class="wft-columns">
                <div class="column col-5 bg--color mt-45 col-mx-auto">
                    <div class="field-group form-group">
                        <label class="form-label" for="input-example-1"><?php esc_html_e( 'Ticker Label', 'wft' ); ?></label>
                        <input type="text" class="form-input" value="<?php if (isset($tickerData)) {  echo esc_html( $tickerData['wft_ticker_title']);}; ?>" name="wft_ticker_title" />
                    </div>


                    <!-- Start Skill Repeater -->
                    <div class="repeater-field">
                        <div id="repeaterticker">
                            <!-- Repeater Heading -->
                            <div class="repeater-heading">
                                <h5 class="pull-left"><?php esc_html_e( 'Ticker Content', 'wft' ); ?></h5>
                                <span class="btn btn-primary add-btn repeater-add-btn">
                                    <?php esc_html_e( 'Add Ticker', 'wft' ); ?>
                                </span>
                            </div>
                            <div class="clearfix"></div>
                            <!-- Repeater Items -->
                            <?php
                            if( ! empty( $tickerlist ) ): 
                                foreach( $tickerlist as $value ):
                            ?>
                            <div class="items" data-group="ticker">
                                <!-- Repeater Content -->
                                <div class="item-content form-group">
                                    <div class="columns">
                                        <div class="column col-5">
                                            <input type="text" class="form-input" id="inputticker" value="<?php echo esc_html( $value ); ?>" placeholder="<?php esc_attr_e( 'Ticker', 'wft' ); ?>" data-skip-name="true" data-name="tickerlist[name][]">
                                        </div>
                                        <!-- Repeater Remove Btn -->
                                        <div class="column col-2 repeater-remove-btn">
                                            <button class="btn btn-danger tricker-remove-btn">
                                                <?php esc_html_e( 'Remove Ticker', 'wft' ); ?>
                                            </button>
                                        </div>
                                    </div>
                                </div>
                                <div class="clearfix"></div>
                            </div>
                            <?php 
                                endforeach;
                            else:
                                ?>
                                <div class="items" data-group="ticker">
                                    <!-- Repeater Content -->
                                    <div class="item-content form-group">
                                        <div class="columns">
                                            <div class="column col-5">
                                                <input type="text" class="form-input" id="inputticker" value="" placeholder="<?php esc_attr_e( 'Ticker', 'wft' ); ?>" data-skip-name="true" data-name="tickerlist[name][]">
                                            </div>
                                            <!-- Repeater Remove Btn -->
                                            <div class="column col-2 repeater-remove-btn">
                                                <button class="btn btn-danger tricker-remove-btn">
                                                    <?php esc_html_e( 'Remove Ticker', 'wft' ); ?>
                                                </button>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="clearfix"></div>
                                </div>
                                <?php
                            endif;
                            ?>
                        </div>
                    </div>
                    <div class="wft-admin-single-field">
                        <label><?php esc_html_e( 'Ticker Label Color', 'wft' ); ?></label>
                        <input type="text" name="wft_ticker_lab_color" value="<?php echo esc_attr( ! empty( $tickerData['wft_ticker_lab_color'] ) ? $tickerData['wft_ticker_lab_color'] : '#fff' ); ?>" class="wft-admin-color-field" />
                    </div>
                    <div class="wft-admin-single-field">
                        <label><?php esc_html_e( 'Ticker Label Background Color', 'wft' ); ?></label>
                        <input type="text" name="wft_ticker_lab_bg" value="<?php echo esc_attr( ! empty( $tickerData['wft_ticker_lab_bg'] ) ? $tickerData['wft_ticker_lab_bg'] : 'rgba(69, 78, 140,0.7)' ); ?>" class="wft-admin-color-field" />
                    </div>
                    <div class="wft-admin-single-field">
                        <label><?php esc_html_e( 'Ticker Color', 'wft' ); ?></label>
                        <input type="text" name="wft_ticker_color" value="<?php echo esc_attr( ! empty( $tickerData['wft_ticker_color'] ) ? $tickerData['wft_ticker_color'] : '#000' ); ?>" class="wft-admin-color-field" />
                    </div>
                    <div class="wft-admin-single-field">
                        <label><?php esc_html_e( 'Ticker Border Color', 'wft' ); ?></label>
                        <input type="text" name="wft_ticker_bord_color" value="<?php echo esc_attr( ! empty( $tickerData['wft_ticker_bord_color'] ) ? $tickerData['wft_ticker_bord_color'] : '' ); ?>" class="wft-admin-color-field" />
                    </div>
                    <div class="wft-admin-single-field">
                        <label><?php esc_html_e( 'Ticker Background Color', 'wft' ); ?></label>
                        <input type="text" name="wft_ticker_bg" value="<?php echo esc_attr( ! empty( $tickerData['wft_ticker_bg'] ) ? $tickerData['wft_ticker_bg'] : '#fff' ); ?>" class="wft-admin-color-field" />
                    </div>
                    <!-- End Skill Repeater  -->
                </div>
            </div>
        </div>
        <?php
        // Add nonce for security and authentication.
        wp_nonce_field( 'wft_ticker_nonce_action', 'wft_ticker_nonce' );
        ?>
    </div>

    <?php
}

// Member save meta data
add_action( 'save_post', 'wft_ticker_save_meta_data', 10, 2 );
function wft_ticker_save_meta_data( $post_id, $post ) {

    //Add nonce for security and authentication.
    $nonce_name   = isset( $_POST['wft_ticker_nonce'] ) ? $_POST['wft_ticker_nonce'] : '';
    $nonce_action = 'wft_ticker_nonce_action';

    //Check if nonce is valid.
    if ( ! wp_verify_nonce( $nonce_name, $nonce_action ) ) {
        return;
    }


    $dataArr = [];

    $dataArr['wft_ticker_title'] = isset( $_POST['wft_ticker_title'] ) ? $_POST['wft_ticker_title'] : '';
    $dataArr['wft_ticker_lab_color'] = isset( $_POST['wft_ticker_lab_color'] ) ? $_POST['wft_ticker_lab_color'] : '';
    $dataArr['wft_ticker_lab_bg'] = isset( $_POST['wft_ticker_lab_bg'] ) ? $_POST['wft_ticker_lab_bg'] : '';
    $dataArr['wft_ticker_bord_color'] = isset( $_POST['wft_ticker_bord_color'] ) ? $_POST['wft_ticker_bord_color'] : '';
    $dataArr['wft_ticker_color'] = isset( $_POST['wft_ticker_color'] ) ? $_POST['wft_ticker_color'] : '';
    $dataArr['wft_ticker_bg'] = isset( $_POST['wft_ticker_bg'] ) ? $_POST['wft_ticker_bg'] : '';
    $dataArr['tickerlist'] = isset( $_POST['tickerlist'] ) ? $_POST['tickerlist'] : '';


    $dataJson = wp_json_encode( $dataArr, JSON_UNESCAPED_UNICODE );

    update_post_meta( $post_id, 'wft_ticker_meta', $dataJson );


}

//  Add wft_ticker post type shortcode columns
add_filter( 'manage_edit-wft_ticker_columns', 'wft_ticker_edit_columns' );
function wft_ticker_edit_columns( $columns ) {

    $columns = array(
        'cb'        => '&lt;input type="checkbox" />',
        'title'     => esc_html__( 'Title', 'wft' ),
        'shortcode' => esc_html__( 'Shortcode', 'wft' ),
        'date'      => esc_html__( 'Date', 'wft' )
    );

    return $columns;
}
//
add_action( 'manage_wft_ticker_posts_custom_column' , 'wft_ticker_custom_columns', 10, 2 );

function wft_ticker_custom_columns( $column, $post_id ) {

    $metaDate = get_post_meta( $post_id, 'wft_ticker_meta', true );

    $jsondecode = json_decode( $metaDate, true );

    switch ( $column ) {
        case 'shortcode':
            if( ! empty( $jsondecode['tickerlist'] ) ) {
                echo '<code>[wft_ticker id="'.absint( $post_id ).'"]</code>';
            }
            
            break;

    }

}